=== modified file 'NEWS'
--- NEWS	2008-03-10 17:13:08 +0000
+++ NEWS	2008-03-10 21:14:06 +0000
@@ -67,6 +67,9 @@
     * Redirecting the output from ``bzr merge`` (when the remembered
       location is used) now works. (John Arbash Meinel)
 
+    * setup.py script explicitly checks for Python version.
+      (Jari Aalto, Alexander Belchenko, #200569)
+
     * Upgrade bundled ConfigObj to version 4.5.2, which properly quotes #
       signs, among other small improvements. (Matt Nordhoff, #86838)
 

=== modified file 'setup.py'
--- setup.py	2008-02-20 10:36:15 +0000
+++ setup.py	2008-03-10 21:14:06 +0000
@@ -9,6 +9,10 @@
 import os
 import sys
 
+if sys.hexversion < 0x02040000:
+    sys.stderr.write("[ERROR] Not a supported Python version. Need 2.4+\n")
+    sys.exit(1)
+
 import bzrlib
 
 ##
@@ -34,35 +38,6 @@
                                        ]},
            }
 
-######################################################################
-# Reinvocation stolen from bzr, we need python2.4 by virtue of bzr_man
-# including bzrlib.help
-
-try:
-    version_info = sys.version_info
-except AttributeError:
-    version_info = 1, 5 # 1.5 or older
-
-REINVOKE = "__BZR_REINVOKE"
-NEED_VERS = (2, 4)
-KNOWN_PYTHONS = ('python2.4',)
-
-if version_info < NEED_VERS:
-    if not os.environ.has_key(REINVOKE):
-        # mutating os.environ doesn't work in old Pythons
-        os.putenv(REINVOKE, "1")
-        for python in KNOWN_PYTHONS:
-            try:
-                os.execvp(python, [python] + sys.argv)
-            except OSError:
-                pass
-    sys.stderr.write("bzr: error: cannot find a suitable python interpreter\n")
-    sys.stderr.write("  (need %d.%d or later)" % NEED_VERS)
-    sys.stderr.write('\n')
-    sys.exit(1)
-if getattr(os, "unsetenv", None) is not None:
-    os.unsetenv(REINVOKE)
-
 
 def get_bzrlib_packages():
     """Recurse through the bzrlib directory, and extract the package names"""

